/**
 * A collection of tree traversers
 */

class Traversers {
    public static void main(String[] args) {
	StrTree tree = new StrTree();
	//insert(tree);
	altinsert(tree);
	System.out.println("1. recursive traverser");
	tree.inTraverse();
	System.out.println("3. iterative traverser using a stack");
	tree.inTraverseStack();
	System.out.println("4. alternative iterative traverser using a stack");
	tree.inTraverseStackAlt();
	System.out.println("5. queue traverser");
	tree.inTraverseQueue();
	System.out.println("6. alternative queue traverser");
	tree.inTraverseQueueAlt();
	System.out.println("7. NextSetup/Next traverser");
	tree.nextSetup();
	while (true) {
		String s = tree.next();
		if (s==null) break;
		System.out.println(s);
	}

	System.out.println("8. stack-based Iterator");
	for (String s : tree) System.out.println(s);
	System.out.println("9: insert while running stack-based Iterator");
	int i=0;
	for (String s : tree) {
		System.out.println(s);
		i++;
		if (i==3) tree.insert("eggplant");
	}
    }

    public static void insert(StrTree sl) {
    	sl.insert("zebra");
    	sl.insert("fresh");
    	sl.insert("antelope");
    	sl.insert("grass,");
    	sl.insert("with");
    	sl.insert("eats");
    	sl.insert("plays");
    }

    public static void altinsert(StrTree sl) {
    	sl.insert("grass,");
    	sl.insert("eats");
    	sl.insert("with");
    	sl.insert("zebra");
    	sl.insert("fresh");
    	sl.insert("antelope");
    	sl.insert("plays");
    }

    /*
    public static IEnumerable demoEnumerator(int max){
	for (int i=1; i<=max; i++) yield return i*i;
    }
    /* */
}
